Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_oper.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_oper.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_oper.F90	(revision 15799)
@@ -762,5 +709,5 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  surfdataqc%vdmean(ji,jj) = 0.0
+                  surfdataqc%vdmean(ji,jj,:) = 0.0
                   zmeanday(ji,jj) = 0.0
                   icount_night(ji,jj) = 0
@@ -775,7 +722,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               ! Increment the temperature field for computing night mean and counter
-               surfdataqc%vdmean(ji,jj) = surfdataqc%vdmean(ji,jj)  &
-                      &                    + psurf(ji,jj) * REAL( imask_night(ji,jj) )
+               ! Increment the model field for computing night mean and counter
+               surfdataqc%vdmean(ji,jj,kvar) = surfdataqc%vdmean(ji,jj,kvar)  &
+                      &                        + psurf(ji,jj) * REAL( imask_night(ji,jj) )
                zmeanday(ji,jj)          = zmeanday(ji,jj) + psurf(ji,jj)
                icount_night(ji,jj)      = icount_night(ji,jj) + imask_night(ji,jj)
@@ -786,15 +733,15 @@
          zdaystp = 1.0 / REAL( kdaystp )
          IF ( idayend == 0 ) THEN
-            IF (lwp) WRITE(numout,*) 'Calculating surfdataqc%vdmean on time-step: ',kt
+            IF (lwp) WRITE(numout,*) 'Calculating surfdataqc%vdmean on time-step: ', kt
             DO jj = 1, jpj
                DO ji = 1, jpi
                   ! Test if "no night" point
                   IF ( icount_night(ji,jj) > 0 ) THEN
-                     surfdataqc%vdmean(ji,jj) = surfdataqc%vdmean(ji,jj) &
-                       &                        / REAL( icount_night(ji,jj) )
+                     surfdataqc%vdmean(ji,jj,kvar) = surfdataqc%vdmean(ji,jj,kvar) &
+                       &                             / REAL( icount_night(ji,jj) )
                   ELSE
                      !At locations where there is no night (e.g. poles),
                      ! calculate daily mean instead of night-time mean.
-                     surfdataqc%vdmean(ji,jj) = zmeanday(ji,jj) * zdaystp
+                     surfdataqc%vdmean(ji,jj,kvar) = zmeanday(ji,jj) * zdaystp
                   ENDIF
                END DO
@@ -814,15 +761,24 @@
          & zmask(imaxifp,imaxjfp,isurf), &
          & zsurf(imaxifp,imaxjfp,isurf), &
-         & zsurftmp(imaxifp,imaxjfp,isurf),  &
-         & zglamf(imaxifp+1,imaxjfp+1,isurf), &
-         & zgphif(imaxifp+1,imaxjfp+1,isurf), &
-         & igrdip1(imaxifp+1,imaxjfp+1,isurf), &
-         & igrdjp1(imaxifp+1,imaxjfp+1,isurf) &
+         & zsurftmp(imaxifp,imaxjfp,isurf) &
          & )
+
+      IF ( k2dint > 4 ) THEN
+         ALLOCATE( &
+            & zglamf(imaxifp+1,imaxjfp+1,isurf),  &
+            & zgphif(imaxifp+1,imaxjfp+1,isurf),  &
+            & igrdip1(imaxifp+1,imaxjfp+1,isurf), &
+            & igrdjp1(imaxifp+1,imaxjfp+1,isurf)  &
+            & )
+      ENDIF
+
+      IF ( ldclim ) THEN
+         ALLOCATE( zclim(imaxifp,imaxjfp,isurf) )
+      ENDIF
 
       DO jobs = surfdataqc%nsurfup + 1, surfdataqc%nsurfup + isurf
          iobs = jobs - surfdataqc%nsurfup
          DO ji = 0, imaxifp
-            imodi = surfdataqc%mi(jobs) - int(imaxifp/2) + ji - 1
+            imodi = surfdataqc%mi(jobs,kvar) - int(imaxifp/2) + ji - 1
             !
             !Deal with wrap around in longitude
@@ -831,5 +787,5 @@
             !
             DO jj = 0, imaxjfp
-               imodj = surfdataqc%mj(jobs) - int(imaxjfp/2) + jj - 1
+               imodj = surfdataqc%mj(jobs,kvar) - int(imaxjfp/2) + jj - 1
                !If model values are out of the domain to the north/south then
                !set them to be the edge of the domain
@@ -837,6 +793,8 @@
                IF ( imodj > jpjglo ) imodj = jpjglo
                !
-               igrdip1(ji+1,jj+1,iobs) = imodi
-               igrdjp1(ji+1,jj+1,iobs) = imodj
+               IF ( k2dint > 4 ) THEN
+                  igrdip1(ji+1,jj+1,iobs) = imodi
+                  igrdjp1(ji+1,jj+1,iobs) = imodj
+               ENDIF
                !
                IF ( ji >= 1 .AND. jj >= 1 ) THEN
@@ -855,10 +813,29 @@
       CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, &
          &                  igrdi, igrdj, psurfmask, zmask )
-      CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, &
-         &                  igrdi, igrdj, psurf, zsurf )
-      CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, &
-         &                  igrdip1, igrdjp1, glamf, zglamf )
-      CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, &
-         &                  igrdip1, igrdjp1, gphif, zgphif )
+
+      ! At the end of the averaging period get interpolated means
+      IF ( ldtime_mean ) THEN
+         IF ( imeanend == 0 ) THEN
+            ALLOCATE( zsurfm(imaxifp,imaxjfp,isurf) )
+            IF (lwp) WRITE(numout,*)' Interpolating the time mean values on time step: ', kt
+            CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, &
+               &                  igrdi, igrdj, surfdataqc%vdmean(:,:,kvar), zsurfm )
+         ENDIF
+      ELSE
+         CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, &
+            &                  igrdi, igrdj, psurf, zsurf )
+      ENDIF
+
+      IF ( k2dint > 4 ) THEN 
+         CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, &
+            &                  igrdip1, igrdjp1, glamf, zglamf )
+         CALL obs_int_comm_2d( imaxifp+1, imaxjfp+1, isurf, kpi, kpj, &
+            &                  igrdip1, igrdjp1, gphif, zgphif )
+      ENDIF
+      
+      IF ( ldclim ) THEN
+         CALL obs_int_comm_2d( imaxifp, imaxjfp, isurf, kpi, kpj, &
+            &                  igrdi, igrdj, pclim, zclim )
+      ENDIF
 
       ! At the end of the day get interpolated means
@@ -870,5 +847,5 @@
 
          CALL obs_int_comm_2d( imaxifp,imaxjfp, isurf, kpi, kpj, igrdi, igrdj, &
-            &               surfdataqc%vdmean(:,:), zsurfm )
+            &               surfdataqc%vdmean(:,:,kvar), zsurfm )
 
       ENDIF
@@ -900,6 +877,6 @@
          zphi = surfdataqc%rphi(jobs)
 
-         IF ( ldnightav .AND. idayend == 0 ) THEN
-            ! Night-time averaged data
+         IF ( ( ldnightav .AND. idayend == 0 ) .OR. (ldtime_mean .AND. imeanend == 0) ) THEN
+            ! Night-time or N=kmeanstp timestep averaged data
             zsurftmp(:,:,iobs) = zsurfm(:,:,iobs)
          ELSE
@@ -907,40 +884,73 @@
          ENDIF
 
-         IF ( k2dint <= 4 ) THEN
-
-            ! Get weights to interpolate the model value to the observation point
-            CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
-               &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
-               &                   zmask(:,:,iobs), zweig, zobsmask )
-
-            ! Interpolate the model value to the observation point 
-            CALL obs_int_h2d( 1, 1, zweig, zsurftmp(:,:,iobs), zext )
-
-         ELSE
-
-            ! Get weights to average the model SLA to the observation footprint
-            CALL obs_avg_h2d_init( 1, 1, imaxifp, imaxjfp, k2dint, zlam,  zphi, &
-               &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
-               &                   zglamf(:,:,iobs), zgphif(:,:,iobs), &
-               &                   zmask(:,:,iobs), plamscl, pphiscl, &
-               &                   lindegrees, zweig, zobsmask )
-
-            ! Average the model SST to the observation footprint
-            CALL obs_avg_h2d( 1, 1, imaxifp, imaxjfp, &
-               &              zweig, zsurftmp(:,:,iobs),  zext )
-
-         ENDIF
-
-         IF ( TRIM(surfdataqc%cvars(1)) == 'SLA' .AND. surfdataqc%nextra == 2 ) THEN
-            ! ... Remove the MDT from the SSH at the observation point to get the SLA
-            surfdataqc%rext(jobs,1) = zext(1)
-            surfdataqc%rmod(jobs,1) = surfdataqc%rext(jobs,1) - surfdataqc%rext(jobs,2)
-         ELSE
-            surfdataqc%rmod(jobs,1) = zext(1)
-         ENDIF
-         
-         IF ( zext(1) == obfillflt ) THEN
-            ! If the observation value is a fill value, set QC flag to bad
-            surfdataqc%nqc(jobs) = 4
+         IF ( ( .NOT. ldtime_mean ) .OR. ( ldtime_mean .AND. imeanend == 0) ) THEN
+
+            IF ( k2dint <= 4 ) THEN
+
+               ! Get weights to interpolate the model value to the observation point
+               CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
+                  &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
+                  &                   zmask(:,:,iobs), zweig, zobsmask )
+
+               ! Interpolate the model value to the observation point 
+               CALL obs_int_h2d( 1, 1, zweig, zsurftmp(:,:,iobs), zext )
+
+               IF ( ldclim ) THEN
+                  CALL obs_int_h2d( 1, 1, zweig, zclim(:,:,iobs), zclm )
+               ENDIF
+
+            ELSE
+
+               ! Get weights to average the model field to the observation footprint
+               CALL obs_avg_h2d_init( 1, 1, imaxifp, imaxjfp, k2dint, zlam,  zphi, &
+                  &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
+                  &                   zglamf(:,:,iobs), zgphif(:,:,iobs), &
+                  &                   zmask(:,:,iobs), plamscl, pphiscl, &
+                  &                   lindegrees, zweig, zobsmask )
+
+               ! Average the model field to the observation footprint
+               CALL obs_avg_h2d( 1, 1, imaxifp, imaxjfp, &
+                  &              zweig, zsurftmp(:,:,iobs),  zext )
+
+               IF ( ldclim ) THEN
+                  CALL obs_avg_h2d( 1, 1, imaxifp, imaxjfp, &
+                     &              zweig, zclim(:,:,iobs),  zclm )
+               ENDIF
+
+            ENDIF
+
+            IF ( TRIM(surfdataqc%cvars(kvar)) == cobsname_sla .AND. PRESENT(kssh) .AND. PRESENT(kmdt) ) THEN
+               ! ... Remove the MDT from the SSH at the observation point to get the SLA
+               surfdataqc%radd(jobs,kssh,kvar) = zext(1)
+               surfdataqc%rmod(jobs,kvar) = surfdataqc%radd(jobs,kssh,kvar) - surfdataqc%rext(jobs,kmdt)
+#if defined key_si3 || defined key_cice
+            ELSE IF ( TRIM(surfdataqc%cvars(kvar)) == cobsname_fbd .AND. PRESENT(kfbd) .AND. PRESENT(ksnow) ) THEN
+               surfdataqc%rmod(jobs,kvar) = zext(1)
+               ! Convert radar freeboard to true freeboard
+               ! (add 1/4 snow depth; 1/4 based on ratio of speed of light in vacuum
+               !  compared to snow (3.0e8 vs 2.4e8 m/s))
+               surfdataqc%radd(jobs,kfbd,kvar) = surfdataqc%robs(jobs,kvar)
+               surfdataqc%robs(jobs,kvar) = surfdataqc%radd(jobs,kfbd,kvar) + 0.25*surfdataqc%rext(jobs,ksnow)
+               ! If the corrected freeboard observation is outside -0.3 to 3.0 m (CPOM) then set the QC flag to bad
+               IF ((surfdataqc%robs(jobs,kvar) < -0.3) .OR. (surfdataqc%robs(jobs,kvar) > 3.0)) THEN
+                  surfdataqc%nqc(jobs) = 4
+               ENDIF           
+               ! Convert corrected freeboard to ice thickness following Tilling et al. (2016)
+               surfdataqc%robs(jobs,kvar) = (surfdataqc%robs(jobs,kvar)*rhow + surfdataqc%rext(jobs,ksnow)*rhos)/ &
+                  &                         (rhow - rhoi)
+#endif
+            ELSE
+               surfdataqc%rmod(jobs,kvar) = zext(1)
+            ENDIF
+
+            IF ( ldclim ) THEN
+               surfdataqc%radd(jobs,kclim,kvar) = zclm(1)
+            ENDIF
+
+            IF ( zext(1) == obfillflt ) THEN
+               ! If the observation value is a fill value, set QC flag to bad
+               surfdataqc%nqc(jobs) = 4
+            ENDIF
+
          ENDIF
 
@@ -956,13 +966,22 @@
          & zmask, &
          & zsurf, &
-         & zsurftmp, &
-         & zglamf, &
-         & zgphif, &
-         & igrdip1,&
-         & igrdjp1 &
+         & zsurftmp &
          & )
 
-      ! At the end of the day also deallocate night-time mean array
-      IF ( idayend == 0 .AND. ldnightav ) THEN
+      IF ( k2dint > 4 ) THEN
+         DEALLOCATE( &     
+            & zglamf, &
+            & zgphif, &
+            & igrdip1,&
+            & igrdjp1 &
+            & )
+      ENDIF
+            
+      IF ( ldclim ) THEN
+         DEALLOCATE( zclim )
+      ENDIF
+
+      ! At the end of the day also deallocate time mean array
+      IF ( ( idayend == 0 .AND. ldnightav ) .OR. ( imeanend == 0 .AND. ldtime_mean ) ) THEN
          DEALLOCATE( &
             & zsurfm  &
@@ -970,5 +989,7 @@
       ENDIF
       !
-      surfdataqc%nsurfup = surfdataqc%nsurfup + isurf
+      IF ( kvar == surfdataqc%nvar ) THEN
+         surfdataqc%nsurfup = surfdataqc%nsurfup + isurf
+      ENDIF
       !
    END SUBROUTINE obs_surf_opt
